com.fasterxml.jackson.core.json

## Class ReaderBasedJsonParser

- java.lang.Object
- - com.fasterxml.jackson.core.JsonParser
  - - com.fasterxml.jackson.core.base.ParserMinimalBase
    - - com.fasterxml.jackson.core.base.ParserBase
      - - com.fasterxml.jackson.core.json.ReaderBasedJsonParser

All Implemented Interfaces:
  Versioned, Closeable, AutoCloseable

    public class ReaderBasedJsonParser
    extends ParserBase

This is a concrete implementation of `JsonParser`, which is based on a `Reader` to handle low-level character conversion tasks.

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonParser

`JsonParser.Feature, JsonParser.NumberType`

### Field Summary

Fields
`protected boolean` `_bufferRecyclable` Flag that indicates whether the input buffer is recycable (and needs to be returned to recycler once we are done) or not.
`protected int` `_hashSeed`
`protected static int[]` `_icLatin1`
`protected char[]` `_inputBuffer` Current buffer from which data is read; generally data is read into buffer from input source.
`protected int` `_nameStartCol`
`protected long` `_nameStartOffset` Value of `ParserBase._inputPtr` at the time when the first character of name token was read.
`protected int` `_nameStartRow`
`protected ObjectCodec` `_objectCodec`
`protected Reader` `_reader` Reader that can be used for reading more content, if one buffer from input source, but in some cases pre-loaded buffer is handed to the parser.
`protected CharsToNameCanonicalizer` `_symbols`
`protected boolean` `_tokenIncomplete` Flag that indicates that the current token has not yet been fully processed, and needs to be finished for some access (or skipped to obtain the next token)

### Fields inherited from class com.fasterxml.jackson.core.base.ParserBase

`_binaryValue, _byteArrayBuilder, _closed, _currInputProcessed, _currInputRow, _currInputRowStart, _expLength, _fractLength, _inputEnd, _inputPtr, _intLength, _ioContext, _nameCopied, _nameCopyBuffer, _nextToken, _numberBigDecimal, _numberBigInt, _numberDouble, _numberInt, _numberLong, _numberNegative, _numTypesValid, _parsingContext, _textBuffer, _tokenInputCol, _tokenInputRow, _tokenInputTotal, JSON_READ_CAPABILITIES`

### Fields inherited from class com.fasterxml.jackson.core.base.ParserMinimalBase

`_currToken, _lastClearedToken, BD_MAX_INT, BD_MAX_LONG, BD_MIN_INT, BD_MIN_LONG, BI_MAX_INT, BI_MAX_LONG, BI_MIN_INT, BI_MIN_LONG, CHAR_NULL, INT_0, INT_9, INT_APOS, INT_ASTERISK, INT_BACKSLASH, INT_COLON, INT_COMMA, INT_CR, INT_e, INT_E, INT_HASH, INT_LBRACKET, INT_LCURLY, INT_LF, INT_MINUS, INT_PERIOD, INT_PLUS, INT_QUOTE, INT_RBRACKET, INT_RCURLY, INT_SLASH, INT_SPACE, INT_TAB, MAX_ERROR_TOKEN_LENGTH, MAX_INT_D, MAX_INT_L, MAX_LONG_D, MIN_INT_D, MIN_INT_L, MIN_LONG_D, NO_BYTES, NO_INTS, NR_BIGDECIMAL, NR_BIGINT, NR_DOUBLE, NR_FLOAT, NR_INT, NR_LONG, NR_UNKNOWN`

### Fields inherited from class com.fasterxml.jackson.core.JsonParser

`_features, _requestPayload, DEFAULT_READ_CAPABILITIES`

### Constructor Summary

Constructors
Constructor and Description
`ReaderBasedJsonParser(IOContext ctxt, int features, Reader r, ObjectCodec codec, CharsToNameCanonicalizer st)` Method called when input comes as a `Reader`, and buffer allocation can be done using default mechanism.
`ReaderBasedJsonParser(IOContext ctxt, int features, Reader r, ObjectCodec codec, CharsToNameCanonicalizer st, char[] inputBuffer, int start, int end, boolean bufferRecyclable)` Method called when caller wants to provide input buffer directly, and it may or may not be recyclable use standard recycle context.

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`protected void` `_closeInput()`
`protected byte[]` `_decodeBase64(Base64Variant b64variant)` Efficient handling for incremental parsing of base64-encoded textual content.
`protected char` `_decodeEscaped()` Method that sub-classes must implement to support escaped sequences in base64-encoded sections.
`protected void` `_finishString()`
`protected void` `_finishString2()`
`protected String` `_getText2(JsonToken t)`
`protected JsonToken` `_handleApos()`
`protected JsonToken` `_handleInvalidNumberStart(int ch, boolean negative)` Method called if expected numeric value (due to leading sign) does not look like a number
`protected String` `_handleOddName(int i)` Method called when we see non-white space character other than double quote, when expecting a field name.
`protected JsonToken` `_handleOddValue(int i)` Method for handling cases where first non-space character of an expected value token is not legal for standard JSON content.
`protected boolean` `_isNextTokenNameMaybe(int i, String nameToMatch)`
`protected boolean` `_loadMore()`
`protected void` `_loadMoreGuaranteed()`
`protected void` `_matchToken(String matchStr, int i)` Helper method for checking whether input matches expected token
`protected String` `_parseAposName()`
`protected JsonToken` `_parseFloatThatStartsWithPeriod()`
`protected String` `_parseName()`
`protected JsonToken` `_parseNegNumber()`
`protected JsonToken` `_parsePosNumber(int ch)` Initial parsing method for number values.
`protected int` `_readBinary(Base64Variant b64variant, OutputStream out, byte[] buffer)`
`protected void` `_releaseBuffers()` Method called to release internal buffers owned by the base reader.
`protected void` `_reportInvalidToken(String matchedPart)`
`protected void` `_reportInvalidToken(String matchedPart, String msg)`
`protected void` `_skipCR()` We actually need to check the character value here (to see if we have \n following \r).
`protected void` `_skipString()` Method called to skim through rest of unparsed String value, if it is not needed.
`void` `finishToken()` Method that may be used to force full handling of the current token so that even if lazy processing is enabled, the whole contents are read for possible retrieval.
`byte[]` `getBinaryValue(Base64Variant b64variant)` Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value.
`ObjectCodec` `getCodec()` Accessor for `ObjectCodec` associated with this parser, if any.
`JsonLocation` `getCurrentLocation()` Method that returns location of the last processed character; usually for error reporting purposes
`Object` `getInputSource()` Method that can be used to get access to object that is used to access input being parsed; this is usually either `InputStream` or `Reader`, depending on what parser was constructed with.
`protected char` `getNextChar(String eofMsg)` Deprecated.
`protected char` `getNextChar(String eofMsg, JsonToken forToken)`
`JacksonFeatureSet<StreamReadCapability>` `getReadCapabilities()` Accessor for getting metadata on capabilities of this parser, based on underlying data format being read (directly or indirectly).
`String` `getText()` Method for accessing textual representation of the current event; if no current event (before first call to `nextToken()`, or after encountering end-of-input), returns null.
`int` `getText(Writer writer)` Method to read the textual representation of the current token in chunks and pass it to the given Writer.
`char[]` `getTextCharacters()` Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information.
`int` `getTextLength()` Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.
`int` `getTextOffset()` Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.
`JsonLocation` `getTokenLocation()` Method that return the starting location of the current token; that is, position of the first character from input that starts the current token.
`String` `getValueAsString()` Method that will try to convert value of current token to a `String`.
`String` `getValueAsString(String defValue)` Method that will try to convert value of current token to a `String`.
`Boolean` `nextBooleanValue()` Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE` returns matching Boolean value; otherwise return null.
`String` `nextFieldName()` Method that fetches next token (as if calling `JsonParser.nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME`; if it is, returns same as `JsonParser.getCurrentName()`, otherwise null.
`boolean` `nextFieldName(SerializableString sstr)` Method that fetches next token (as if calling `JsonParser.nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME` with specified name and returns result of that comparison.
`int` `nextIntValue(int defaultValue)` Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 32-bit int value; otherwise returns specified default value It is functionally equivalent to:
`long` `nextLongValue(long defaultValue)` Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 64-bit long value; otherwise returns specified default value It is functionally equivalent to:
`String` `nextTextValue()` Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_STRING` returns contained String value; otherwise returns null.
`JsonToken` `nextToken()` Main iteration method, which will advance stream enough to determine type of the next token, if any.
`int` `readBinaryValue(Base64Variant b64variant, OutputStream out)` Similar to `JsonParser.readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.
`int` `releaseBuffered(Writer w)` Method that can be called to push back any content that has been read but not consumed by the parser.
`void` `setCodec(ObjectCodec c)` Setter that allows defining `ObjectCodec` associated with this parser, if any.

### Methods inherited from class com.fasterxml.jackson.core.base.ParserBase

`_checkStdFeatureChanges, _decodeBase64Escape, _decodeBase64Escape, _eofAsNextChar, _getByteArrayBuilder, _getSourceReference, _handleBase64MissingPadding, _handleEOF, _handleUnrecognizedCharacterEscape, _parseIntValue, _parseNumericValue, _reportMismatchedEndMarker, _reportTooLongIntegral, _throwUnquotedSpace, _validJsonTokenList, _validJsonValueList, close, convertNumberToBigDecimal, convertNumberToBigInteger, convertNumberToDouble, convertNumberToInt, convertNumberToLong, disable, enable, getBigIntegerValue, getCurrentName, getCurrentValue, getDecimalValue, getDoubleValue, getFloatValue, getIntValue, getLongValue, getNumberType, getNumberValue, getNumberValueExact, getParsingContext, getTokenCharacterOffset, getTokenColumnNr, getTokenLineNr, growArrayBy, hasTextCharacters, isClosed, isNaN, loadMore, loadMoreGuaranteed, overrideCurrentName, overrideStdFeatures, reportInvalidBase64Char, reportInvalidBase64Char, reset, resetAsNaN, resetFloat, resetInt, setCurrentValue, setFeatureMask, version`

### Methods inherited from class com.fasterxml.jackson.core.base.ParserMinimalBase

`_ascii, _asciiBytes, _constructError, _decodeBase64, _getCharDesc, _hasTextualNull, _longIntegerDesc, _longNumberDesc, _reportError, _reportError, _reportError, _reportInputCoercion, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOFInValue, _reportInvalidEOFInValue, _reportMissingRootWS, _reportUnexpectedChar, _throwInternal, _throwInvalidSpace, _wrapError, clearCurrentToken, currentToken, currentTokenId, getCurrentToken, getCurrentTokenId, getLastClearedToken, getValueAsBoolean, getValueAsDouble, getValueAsInt, getValueAsInt, getValueAsLong, getValueAsLong, hasCurrentToken, hasToken, hasTokenId, isExpectedNumberIntToken, isExpectedStartArrayToken, isExpectedStartObjectToken, nextValue, reportInvalidNumber, reportOverflowInt, reportOverflowInt, reportOverflowInt, reportOverflowLong, reportOverflowLong, reportOverflowLong, reportUnexpectedNumberChar, skipChildren`

### Methods inherited from class com.fasterxml.jackson.core.JsonParser

`_codec, _constructError, _reportUnsupportedOperation, canParseAsync, canReadObjectId, canReadTypeId, canUseSchema, configure, currentName, getBinaryValue, getBooleanValue, getByteValue, getEmbeddedObject, getFeatureMask, getFormatFeatures, getNonBlockingInputFeeder, getObjectId, getSchema, getShortValue, getTypeId, getValueAsBoolean, getValueAsDouble, isEnabled, isEnabled, overrideFormatFeatures, readBinaryValue, readValueAs, readValueAs, readValueAsTree, readValuesAs, readValuesAs, releaseBuffered, requiresCustomCodec, setRequestPayloadOnError, setRequestPayloadOnError, setRequestPayloadOnError, setSchema`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _icLatin1

    protected static final int[] _icLatin1

#### _reader

    protected Reader _reader

Reader that can be used for reading more content, if one buffer from input source, but in some cases pre-loaded buffer is handed to the parser.

#### _inputBuffer

    protected char[] _inputBuffer

Current buffer from which data is read; generally data is read into buffer from input source.

#### _bufferRecyclable

    protected boolean _bufferRecyclable

Flag that indicates whether the input buffer is recycable (and needs to be returned to recycler once we are done) or not.

If it is not, it also means that parser can NOT modify underlying buffer.

#### _objectCodec

    protected ObjectCodec _objectCodec

#### _symbols

    protected final CharsToNameCanonicalizer _symbols

#### _hashSeed

    protected final int _hashSeed

#### _tokenIncomplete

    protected boolean _tokenIncomplete

Flag that indicates that the current token has not yet been fully processed, and needs to be finished for some access (or skipped to obtain the next token)

#### _nameStartOffset

    protected long _nameStartOffset

Value of `ParserBase._inputPtr` at the time when the first character of name token was read. Used for calculating token location when requested; combined with `ParserBase._currInputProcessed`, may be updated appropriately as needed.

Since:
  2.7

#### _nameStartRow

    protected int _nameStartRow

Since:
  2.7

#### _nameStartCol

    protected int _nameStartCol

Since:
  2.7

### Constructor Detail

#### ReaderBasedJsonParser

    public ReaderBasedJsonParser(IOContext ctxt,
                                 int features,
                                 Reader r,
                                 ObjectCodec codec,
                                 CharsToNameCanonicalizer st,
                                 char[] inputBuffer,
                                 int start,
                                 int end,
                                 boolean bufferRecyclable)

Method called when caller wants to provide input buffer directly, and it may or may not be recyclable use standard recycle context.

Since:
  2.4

#### ReaderBasedJsonParser

    public ReaderBasedJsonParser(IOContext ctxt,
                                 int features,
                                 Reader r,
                                 ObjectCodec codec,
                                 CharsToNameCanonicalizer st)

Method called when input comes as a `Reader`, and buffer allocation can be done using default mechanism.

### Method Detail

#### getCodec

    public ObjectCodec getCodec()

Description copied from class: `JsonParser`
Accessor for `ObjectCodec` associated with this parser, if any. Codec is used by `JsonParser.readValueAs(Class)` method (and its variants).

Specified by:
  `getCodec` in class `JsonParser`
Returns:
  Codec assigned to this parser, if any; `null` if none

#### setCodec

    public void setCodec(ObjectCodec c)

Description copied from class: `JsonParser`
Setter that allows defining `ObjectCodec` associated with this parser, if any. Codec is used by `JsonParser.readValueAs(Class)` method (and its variants).

Specified by:
  `setCodec` in class `JsonParser`
Parameters:
  `c` - Codec to assign, if any; `null` if none

#### getReadCapabilities

    public JacksonFeatureSet<StreamReadCapability> getReadCapabilities()

Description copied from class: `JsonParser`
Accessor for getting metadata on capabilities of this parser, based on underlying data format being read (directly or indirectly).

Overrides:
  `getReadCapabilities` in class `JsonParser`
Returns:
  Set of read capabilities for content to read via this parser

#### releaseBuffered

    public int releaseBuffered(Writer w)
                        throws IOException

Description copied from class: `JsonParser`
Method that can be called to push back any content that has been read but not consumed by the parser. This is usually done after reading all content of interest using parser. Content is released by writing it to given writer if possible; if underlying input is char-based it can released, if not (byte-based) it can not.

Overrides:
  `releaseBuffered` in class `JsonParser`
Parameters:
  `w` - Writer to which buffered but unprocessed content is written to
Returns:
  -1 if the underlying content source is not char-based (that is, input can not be sent to `Writer`; otherwise number of chars released (0 if there was nothing to release)
Throws:
  `IOException` - if write using Writer threw exception

#### getInputSource

    public Object getInputSource()

Description copied from class: `JsonParser`
Method that can be used to get access to object that is used to access input being parsed; this is usually either `InputStream` or `Reader`, depending on what parser was constructed with. Note that returned value may be null in some cases; including case where parser implementation does not want to exposed raw source to caller. In cases where input has been decorated, object returned here is the decorated version; this allows some level of interaction between users of parser and decorator object.

In general use of this accessor should be considered as "last effort", i.e. only used if no other mechanism is applicable.

Overrides:
  `getInputSource` in class `JsonParser`
Returns:
  Input source this parser was configured with

#### getNextChar

    @Deprecated
    protected char getNextChar(String eofMsg)
                                    throws IOException

Deprecated.

Throws:
  `IOException`

#### getNextChar

    protected char getNextChar(String eofMsg,
                               JsonToken forToken)
                        throws IOException

Throws:
  `IOException`

#### _closeInput

    protected void _closeInput()
                        throws IOException

Specified by:
  `_closeInput` in class `ParserBase`
Throws:
  `IOException`

#### _releaseBuffers

    protected void _releaseBuffers()
                            throws IOException

Method called to release internal buffers owned by the base reader. This may be called along with `_closeInput()` (for example, when explicitly closing this reader instance), or separately (if need be).

Overrides:
  `_releaseBuffers` in class `ParserBase`
Throws:
  `IOException`

#### _loadMoreGuaranteed

    protected void _loadMoreGuaranteed()
                                throws IOException

Throws:
  `IOException`

#### _loadMore

    protected boolean _loadMore()
                         throws IOException

Throws:
  `IOException`

#### getText

    public final String getText()
                         throws IOException

Method for accessing textual representation of the current event; if no current event (before first call to `nextToken()`, or after encountering end-of-input), returns null. Method can be called for any event.

Specified by:
  `getText` in class `ParserMinimalBase`
Returns:
  Textual value associated with the current token (one returned by `JsonParser.nextToken()` or other iteration methods)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getText

    public int getText(Writer writer)
                throws IOException

Description copied from class: `JsonParser`
Method to read the textual representation of the current token in chunks and pass it to the given Writer. Conceptually same as calling:

      writer.write(parser.getText());

but should typically be more efficient as longer content does need to be combined into a single `String` to return, and write can occur directly from intermediate buffers Jackson uses.

Overrides:
  `getText` in class `JsonParser`
Parameters:
  `writer` - Writer to write textual content to
Returns:
  The number of characters written to the Writer
Throws:
  `IOException` - for low-level read issues or writes using passed `writer`, or `JsonParseException` for decoding problems

#### getValueAsString

    public final String getValueAsString()
                                  throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and null token), default value of null will be returned; no exceptions are thrown.

Overrides:
  `getValueAsString` in class `ParserMinimalBase`
Returns:
  `String` value current token is converted to, if possible; `null` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getValueAsString

    public final String getValueAsString(String defValue)
                                  throws IOException

Description copied from class: `JsonParser`
Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and null token), specified default value will be returned; no exceptions are thrown.

Overrides:
  `getValueAsString` in class `ParserMinimalBase`
Parameters:
  `defValue` - Default value to return if conversion to `String` is not possible
Returns:
  `String` value current token is converted to, if possible; `def` otherwise
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### _getText2

    protected final String _getText2(JsonToken t)

#### getTextCharacters

    public final char[] getTextCharacters()
                                   throws IOException

Description copied from class: `JsonParser`
Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information. Note, however, that:

- Textual contents are not guaranteed to start at index 0 (rather, call `JsonParser.getTextOffset()`) to know the actual offset
- Length of textual contents may be less than the length of returned buffer: call `JsonParser.getTextLength()` for actual length of returned content.

Note that caller MUST NOT modify the returned character array in any way -- doing so may corrupt current parser state and render parser instance useless.

The only reason to call this method (over `JsonParser.getText()`) is to avoid construction of a String object (which will make a copy of contents).

Specified by:
  `getTextCharacters` in class `ParserMinimalBase`
Returns:
  Buffer that contains the current textual value (but not necessarily at offset 0, and not necessarily until the end of buffer)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getTextLength

    public final int getTextLength()
                            throws IOException

Description copied from class: `JsonParser`
Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.

Specified by:
  `getTextLength` in class `ParserMinimalBase`
Returns:
  Number of characters within buffer returned by `JsonParser.getTextCharacters()` that are part of textual content of the current token.
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getTextOffset

    public final int getTextOffset()
                            throws IOException

Description copied from class: `JsonParser`
Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.

Specified by:
  `getTextOffset` in class `ParserMinimalBase`
Returns:
  Offset of the first character within buffer returned by `JsonParser.getTextCharacters()` that is part of textual content of the current token.
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### getBinaryValue

    public byte[] getBinaryValue(Base64Variant b64variant)
                          throws IOException

Description copied from class: `JsonParser`
Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value. It works similar to getting String value via `JsonParser.getText()` and decoding result (except for decoding part), but should be significantly more performant.

Note that non-decoded textual contents of the current token are not guaranteed to be accessible after this method is called. Current implementation, for example, clears up textual content during decoding. Decoded binary content, however, will be retained until parser is advanced to the next event.

Overrides:
  `getBinaryValue` in class `ParserBase`
Parameters:
  `b64variant` - Expected variant of base64 encoded content (see `Base64Variants` for definitions of "standard" variants).
Returns:
  Decoded binary data
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### readBinaryValue

    public int readBinaryValue(Base64Variant b64variant,
                               OutputStream out)
                        throws IOException

Description copied from class: `JsonParser`
Similar to `JsonParser.readBinaryValue(OutputStream)` but allows explicitly specifying base64 variant to use.

Overrides:
  `readBinaryValue` in class `JsonParser`
Parameters:
  `b64variant` - base64 variant to use
  `out` - Output stream to use for passing decoded binary data
Returns:
  Number of bytes that were decoded and written via `OutputStream`
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### _readBinary

    protected int _readBinary(Base64Variant b64variant,
                              OutputStream out,
                              byte[] buffer)
                       throws IOException

Throws:
  `IOException`

#### nextToken

    public final JsonToken nextToken()
                              throws IOException

Description copied from class: `JsonParser`
Main iteration method, which will advance stream enough to determine type of the next token, if any. If none remaining (stream has no content other than possible white space before ending), null will be returned.

Specified by:
  `nextToken` in class `ParserMinimalBase`
Returns:
  Next token from the stream, if any found, or null to indicate end-of-input
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### finishToken

    public void finishToken()
                     throws IOException

Description copied from class: `JsonParser`
Method that may be used to force full handling of the current token so that even if lazy processing is enabled, the whole contents are read for possible retrieval. This is usually used to ensure that the token end location is available, as well as token contents (similar to what calling, say `JsonParser.getTextCharacters()`, would achieve).

Note that for many dataformat implementations this method will not do anything; this is the default implementation unless overridden by sub-classes.

Overrides:
  `finishToken` in class `JsonParser`
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### nextFieldName

    public boolean nextFieldName(SerializableString sstr)
                          throws IOException

Description copied from class: `JsonParser`
Method that fetches next token (as if calling `JsonParser.nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME` with specified name and returns result of that comparison. It is functionally equivalent to:

      return (nextToken() == JsonToken.FIELD_NAME) && str.getValue().equals(getCurrentName());

but may be faster for parser to verify, and can therefore be used if caller expects to get such a property name from input next.

Overrides:
  `nextFieldName` in class `JsonParser`
Parameters:
  `sstr` - Property name to compare next token to (if next token is `JsonToken.FIELD_NAME`)
Returns:
  `True` if parser advanced to `JsonToken.FIELD_NAME` with specified name; `false` otherwise (different token or non-matching name)
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### nextFieldName

    public String nextFieldName()
                         throws IOException

Description copied from class: `JsonParser`
Method that fetches next token (as if calling `JsonParser.nextToken()`) and verifies whether it is `JsonToken.FIELD_NAME`; if it is, returns same as `JsonParser.getCurrentName()`, otherwise null.

Overrides:
  `nextFieldName` in class `JsonParser`
Returns:
  Name of the the `JsonToken.FIELD_NAME` parser advanced to, if any; `null` if next token is of some other type
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### _isNextTokenNameMaybe

    protected boolean _isNextTokenNameMaybe(int i,
                                            String nameToMatch)
                                     throws IOException

Throws:
  `IOException`

#### nextTextValue

    public final String nextTextValue()
                               throws IOException

Description copied from class: `JsonParser`
Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_STRING` returns contained String value; otherwise returns null. It is functionally equivalent to:

      return (nextToken() == JsonToken.VALUE_STRING) ? getText() : null;

but may be faster for parser to process, and can therefore be used if caller expects to get a String value next from input.

Overrides:
  `nextTextValue` in class `JsonParser`
Returns:
  Text value of the `JsonToken.VALUE_STRING` token parser advanced to; or `null` if next token is of some other type
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### nextIntValue

    public final int nextIntValue(int defaultValue)
                           throws IOException

Description copied from class: `JsonParser`
Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 32-bit int value; otherwise returns specified default value It is functionally equivalent to:

      return (nextToken() == JsonToken.VALUE_NUMBER_INT) ? getIntValue() : defaultValue;

but may be faster for parser to process, and can therefore be used if caller expects to get an int value next from input.

NOTE: value checks are performed similar to `JsonParser.getIntValue()`

Overrides:
  `nextIntValue` in class `JsonParser`
Parameters:
  `defaultValue` - Value to return if next token is NOT of type `JsonToken.VALUE_NUMBER_INT`
Returns:
  Integer (`int`) value of the `JsonToken.VALUE_NUMBER_INT` token parser advanced to; or `defaultValue` if next token is of some other type
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
  `InputCoercionException` - if integer number does not fit in Java `int`

#### nextLongValue

    public final long nextLongValue(long defaultValue)
                             throws IOException

Description copied from class: `JsonParser`
Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_NUMBER_INT` returns 64-bit long value; otherwise returns specified default value It is functionally equivalent to:

      return (nextToken() == JsonToken.VALUE_NUMBER_INT) ? getLongValue() : defaultValue;

but may be faster for parser to process, and can therefore be used if caller expects to get a long value next from input.

NOTE: value checks are performed similar to `JsonParser.getLongValue()`

Overrides:
  `nextLongValue` in class `JsonParser`
Parameters:
  `defaultValue` - Value to return if next token is NOT of type `JsonToken.VALUE_NUMBER_INT`
Returns:
  `long` value of the `JsonToken.VALUE_NUMBER_INT` token parser advanced to; or `defaultValue` if next token is of some other type
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems
  `InputCoercionException` - if integer number does not fit in Java `long`

#### nextBooleanValue

    public final Boolean nextBooleanValue()
                                   throws IOException

Description copied from class: `JsonParser`
Method that fetches next token (as if calling `JsonParser.nextToken()`) and if it is `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE` returns matching Boolean value; otherwise return null. It is functionally equivalent to:

      JsonToken t = nextToken();
      if (t == JsonToken.VALUE_TRUE) return Boolean.TRUE;
      if (t == JsonToken.VALUE_FALSE) return Boolean.FALSE;
      return null;

but may be faster for parser to process, and can therefore be used if caller expects to get a Boolean value next from input.

Overrides:
  `nextBooleanValue` in class `JsonParser`
Returns:
  `Boolean` value of the `JsonToken.VALUE_TRUE` or `JsonToken.VALUE_FALSE` token parser advanced to; or `null` if next token is of some other type
Throws:
  `IOException` - for low-level read issues, or `JsonParseException` for decoding problems

#### _parseFloatThatStartsWithPeriod

    protected final JsonToken _parseFloatThatStartsWithPeriod()
                                                       throws IOException

Throws:
  `IOException`

#### _parsePosNumber

    protected final JsonToken _parsePosNumber(int ch)
                                       throws IOException

Initial parsing method for number values. It needs to be able to parse enough input to be able to determine whether the value is to be considered a simple integer value, or a more generic decimal value: latter of which needs to be expressed as a floating point number. The basic rule is that if the number has no fractional or exponential part, it is an integer; otherwise a floating point number.

Because much of input has to be processed in any case, no partial parsing is done: all input text will be stored for further processing. However, actual numeric value conversion will be deferred, since it is usually the most complicated and costliest part of processing.

Throws:
  `IOException`

#### _parseNegNumber

    protected final JsonToken _parseNegNumber()
                                       throws IOException

Throws:
  `IOException`

#### _handleInvalidNumberStart

    protected JsonToken _handleInvalidNumberStart(int ch,
                                                  boolean negative)
                                           throws IOException

Method called if expected numeric value (due to leading sign) does not look like a number

Throws:
  `IOException`

#### _parseName

    protected final String _parseName()
                               throws IOException

Throws:
  `IOException`

#### _handleOddName

    protected String _handleOddName(int i)
                             throws IOException

Method called when we see non-white space character other than double quote, when expecting a field name. In standard mode will just throw an expection; but in non-standard modes may be able to parse name.

Throws:
  `IOException`

#### _parseAposName

    protected String _parseAposName()
                             throws IOException

Throws:
  `IOException`

#### _handleOddValue

    protected JsonToken _handleOddValue(int i)
                                 throws IOException

Method for handling cases where first non-space character of an expected value token is not legal for standard JSON content.

Throws:
  `IOException`

#### _handleApos

    protected JsonToken _handleApos()
                             throws IOException

Throws:
  `IOException`

#### _finishString

    protected final void _finishString()
                                throws IOException

Overrides:
  `_finishString` in class `ParserBase`
Throws:
  `IOException`

#### _finishString2

    protected void _finishString2()
                           throws IOException

Throws:
  `IOException`

#### _skipString

    protected final void _skipString()
                              throws IOException

Method called to skim through rest of unparsed String value, if it is not needed. This can be done bit faster if contents need not be stored for future access.

Throws:
  `IOException`

#### _skipCR

    protected final void _skipCR()
                          throws IOException

We actually need to check the character value here (to see if we have \n following \r).

Throws:
  `IOException`

#### _decodeEscaped

    protected char _decodeEscaped()
                           throws IOException

Description copied from class: `ParserBase`
Method that sub-classes must implement to support escaped sequences in base64-encoded sections. Sub-classes that do not need base64 support can leave this as is

Overrides:
  `_decodeEscaped` in class `ParserBase`
Throws:
  `IOException`

#### _matchToken

    protected final void _matchToken(String matchStr,
                                     int i)
                              throws IOException

Helper method for checking whether input matches expected token

Throws:
  `IOException`

#### _decodeBase64

    protected byte[] _decodeBase64(Base64Variant b64variant)
                            throws IOException

Efficient handling for incremental parsing of base64-encoded textual content.

Throws:
  `IOException`

#### getTokenLocation

    public JsonLocation getTokenLocation()

Description copied from class: `ParserBase`
Method that return the starting location of the current token; that is, position of the first character from input that starts the current token.

Overrides:
  `getTokenLocation` in class `ParserBase`
Returns:
  Starting location of the token parser currently points to

#### getCurrentLocation

    public JsonLocation getCurrentLocation()

Description copied from class: `ParserBase`
Method that returns location of the last processed character; usually for error reporting purposes

Overrides:
  `getCurrentLocation` in class `ParserBase`
Returns:
  Location of the last processed input unit (byte or character)

#### _reportInvalidToken

    protected void _reportInvalidToken(String matchedPart)
                                throws IOException

Throws:
  `IOException`

#### _reportInvalidToken

    protected void _reportInvalidToken(String matchedPart,
                                       String msg)
                                throws IOException

Throws:
  `IOException`